"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.Function = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * The ``postgresql.Function`` resource creates and manages a function on a PostgreSQL
 * server.
 *
 * ## Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as postgresql from "@pulumi/postgresql";
 *
 * const increment = new postgresql.Function("increment", {
 *     name: "increment",
 *     args: [{
 *         name: "i",
 *         type: "integer",
 *     }],
 *     returns: "integer",
 *     language: "plpgsql",
 *     body: `BEGIN
 *     RETURN i + 1;
 * END;
 * `,
 * });
 * ```
 *
 * ## Import
 *
 * It is possible to import a `postgresql_function` resource with the following
 * command:
 *
 * ```sh
 * $ pulumi import postgresql:index/function:Function function_foo "my_database.my_schema.my_function_name(arguments)"
 * ```
 * Where `my_database` is the name of the database containing the schema,
 * `my_schema` is the name of the schema in the PostgreSQL database, `my_function_name` is the function name to be imported, `arguments` is the argument signature of the function including all non OUT types and
 * `postgresql_schema.function_foo` is the name of the resource whose state will be
 * populated as a result of the command.
 */
class Function extends pulumi.CustomResource {
    /**
     * Get an existing Function resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Function(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Function.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Function.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["args"] = state ? state.args : undefined;
            resourceInputs["body"] = state ? state.body : undefined;
            resourceInputs["database"] = state ? state.database : undefined;
            resourceInputs["dropCascade"] = state ? state.dropCascade : undefined;
            resourceInputs["language"] = state ? state.language : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["parallel"] = state ? state.parallel : undefined;
            resourceInputs["returns"] = state ? state.returns : undefined;
            resourceInputs["schema"] = state ? state.schema : undefined;
            resourceInputs["securityDefiner"] = state ? state.securityDefiner : undefined;
            resourceInputs["strict"] = state ? state.strict : undefined;
            resourceInputs["volatility"] = state ? state.volatility : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.body === undefined) && !opts.urn) {
                throw new Error("Missing required property 'body'");
            }
            resourceInputs["args"] = args ? args.args : undefined;
            resourceInputs["body"] = args ? args.body : undefined;
            resourceInputs["database"] = args ? args.database : undefined;
            resourceInputs["dropCascade"] = args ? args.dropCascade : undefined;
            resourceInputs["language"] = args ? args.language : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["parallel"] = args ? args.parallel : undefined;
            resourceInputs["returns"] = args ? args.returns : undefined;
            resourceInputs["schema"] = args ? args.schema : undefined;
            resourceInputs["securityDefiner"] = args ? args.securityDefiner : undefined;
            resourceInputs["strict"] = args ? args.strict : undefined;
            resourceInputs["volatility"] = args ? args.volatility : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(Function.__pulumiType, name, resourceInputs, opts);
    }
}
exports.Function = Function;
/** @internal */
Function.__pulumiType = 'postgresql:index/function:Function';
//# sourceMappingURL=function.js.map