"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.PhysicalReplicationSlot = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * The ``postgresql.PhysicalReplicationSlot`` resource creates and manages a physical replication slot on a PostgreSQL
 * server. This is useful to setup a cross datacenter replication, with Patroni for example, or permit
 * any stand-by cluster to replicate physically data.
 *
 * ## Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as postgresql from "@pulumi/postgresql";
 *
 * const mySlot = new postgresql.PhysicalReplicationSlot("my_slot", {name: "my_slot"});
 * ```
 */
class PhysicalReplicationSlot extends pulumi.CustomResource {
    /**
     * Get an existing PhysicalReplicationSlot resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new PhysicalReplicationSlot(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of PhysicalReplicationSlot.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === PhysicalReplicationSlot.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["name"] = state ? state.name : undefined;
        }
        else {
            const args = argsOrState;
            resourceInputs["name"] = args ? args.name : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(PhysicalReplicationSlot.__pulumiType, name, resourceInputs, opts);
    }
}
exports.PhysicalReplicationSlot = PhysicalReplicationSlot;
/** @internal */
PhysicalReplicationSlot.__pulumiType = 'postgresql:index/physicalReplicationSlot:PhysicalReplicationSlot';
//# sourceMappingURL=physicalReplicationSlot.js.map